# `memcached` module
## Metrics
Source: https://github.com/memcached/memcached/blob/master/doc/protocol.txt
| Metric name | Labels | Description | 
| ----------- | ------ | ---- |
| openio_memcached_accepting_conns                  | `service`, `service_type`, `service_addr`                     | `accepting_conns` |
| openio_memcached_stored_items                     | `service`, `service_type`, `service_addr`                     | `curr_items` |
| openio_memcached_stored_items_total               | `service`, `service_type`, `service_addr`                     | `total_items` |
| openio_memcached_listen_disabled_total            | `service`, `service_type`, `service_addr`                     | `listen_disabled_num` |
| openio_memcached_listen_disabled_duration_seconds | `service`, `service_type`, `service_addr`                     | `time_in_listen_disabled_us` |
| openio_memcached_commands_total                   | `service`, `service_type`, `service_addr`, `command`          | `cmd_get`, `cmd_set`, `cmd_flush`, `cmd_touch` |
| openio_memcached_connections                      | `service`, `service_type`, `service_addr`                     | `curr_connections` |
| openio_memcached_connections_max                  | `service`, `service_type`, `service_addr`                     | `max_connections` |
| openio_memcached_connections_total                | `service`, `service_type`, `service_addr`                     | `total_connections` |
| openio_memcached_direct_reclaims_total            | `service`, `service_type`, `service_addr`                     | `direct_reclaims` |
| openio_memcached_hash_is_expanding                | `service`, `service_type`, `service_addr`                     | `hash_is_expanding` |
| openio_memcached_hash_size_bytes                  | `service`, `service_type`, `service_addr`                     | `hash_bytes` |
| openio_memcached_io_bytes_total                   | `service`, `service_type`, `service_addr`, `direction`        | `bytes_read` `bytes_written` |
| openio_memcached_log_workers_total                | `service`, `service_type`, `service_addr`, `state`            | `log_worker_dropped`, `log_worker_written` |
| openio_memcached_log_watchers_total               | `service`, `service_type`, `service_addr`, `state`            | `log_watcher_skipped`, `log_watcher_skipped` |
| openio_memcached_lru_crawler_items_checked_total  | `service`, `service_type`, `service_addr`                     | `crawler_items_checked` |
| openio_memcached_lru_crawler_reclaimed_total      | `service`, `service_type`, `service_addr`                     | `crawler_reclaimed` |
| openio_memcached_lru_crawler_running              | `service`, `service_type`, `service_addr`                     | `lru_crawler_running` |
| openio_memcached_lru_crawler_starts_total         | `service`, `service_type`, `service_addr`                     | `lru_crawler_starts` |
| openio_memcached_lru_evictions_total              | `service`, `service_type`, `service_addr`, `type`             | `evictions`, `evicted_unfetch`, `evected_active` |
| openio_memcached_lru_expires_total                | `service`, `service_type`, `service_addr`                     | `expired_unfetched` |
| openio_memcached_lru_moves_total                  | `service`, `service_type`, `service_addr`, `type`             | `moves_to_cold`, `moves_to_warm`, `moves_within_lru` |
| openio_memcached_lru_reclaimed_total              | `service`, `service_type`, `service_addr`                     | `reclaimed` |
| openio_memcached_malloc_fails                     | `service`, `service_type`, `service_addr`                     | `malloc_fails` |
| openio_memcached_rejected_connections             | `service`, `service_type`, `service_addr`                     | `rejected_connections` |
| openio_memcached_cache_commands_total             | `service`, `service_type`, `service_addr`, `command`, `cache` | `^(get|delete|incr|decr|cas|touch)_(hits|misses|badval|expired|flushed)$` |
| openio_memcached_size_bytes                       | `service`, `service_type`, `service_addr`                     | `bytes` |
| openio_memcached_size_bytes_max                   | `service`, `service_type`, `service_addr`                     | `limit_maxbytes` |
| openio_memcached_threads                          | `service`, `service_type`, `service_addr`                     | `threads` |
| openio_memcached_uptime_seconds                   | `service`, `service_type`, `service_addr`                     | `uptime` |
| openio_memcached_slab_actives_total               | `service`, `service_type`, `service_addr`                     | `active_slabs` |
| openio_memcached_slab_memory_size_bytes_total     | `service`, `service_type`, `service_addr`                     | `total_malloced` |
| openio_memcached_slab_chunk_size_bytes            | `service`, `service_type`, `service_addr`, `slab`             | `chunk_size` |
| openio_memcached_slab_chunks_per_page             | `service`, `service_type`, `service_addr`, `slab`             | `chunks_per_page` |
| openio_memcached_slab_chunks_total                | `service`, `service_type`, `service_addr`, `slab`             | `total_chunks` |
| openio_memcached_slab_commands_total              | `service`, `service_type`, `service_addr`, `slab`, `command`  | `get_hits`, `cmd_set`, `delete_hits`, `inc_hits`, `decr_hits`, `cas_hits`, `cas_badval`, `touch_hits` |
| openio_memcached_slab_free_chunks_end             | `service`, `service_type`, `service_addr`, `slab`             | `free_chunks_end` |
| openio_memcached_slab_global_page_pool            | `service`, `service_type`, `service_addr`                     | `slab_global_page_pool` |
| openio_memcached_slab_mem_requested_bytes         | `service`, `service_type`, `service_addr`, `slab`             | `mem_requested` |
| openio_memcached_slab_pages_total                 | `service`, `service_type`, `service_addr`, `slab`             | `total_pages` |
| openio_memcached_slab_reassign_running            | `service`, `service_type`, `service_addr`                     | `slab_reassign_running` |
| openio_memcached_slabs_moved_total                | `service`, `service_type`, `service_addr`                     | `slabs_moved` |
| openio_memcached_slab_reassigns                   | `service`, `service_type`, `service_addr`, `type`             | `slab_reassign_rescues`, `slab_reassign_evictions_nomem`, `slab_reassign_chunk_rescues`, `slab_reassign_inline_reclaim`, `slab_reassign_busy_items`, `slab_reassign_busy_deletes` |
| openio_memcached_slab_wasted_bytes                | `service`, `service_type`, `service_addr`, `slab`             | `(total_chunks * chunk_size) - mem_requested` |
### Sample
```
openio_memcached_accepting_conns{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 1.000000
openio_memcached_commands_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",command="touch"} 0.000000
openio_memcached_connections{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 20.000000
openio_memcached_connections_max{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 8192.000000
openio_memcached_connections_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 25238.000000
openio_memcached_direct_reclaims_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 49183.000000
openio_memcached_hash_is_expanding{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 0.000000
openio_memcached_hash_size_bytes{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 524288.000000
openio_memcached_io_bytes_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",direction="out"} 675643569.000000
openio_memcached_log_workers_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",state="written"} 0.000000
openio_memcached_lru_crawler_items_checked_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 742238.000000
openio_memcached_lru_crawler_reclaimed_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 0.000000
openio_memcached_lru_crawler_running{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 0.000000
openio_memcached_lru_crawler_starts_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 11735.000000
openio_memcached_lru_evictions_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",type="valid"} 49183.000000
openio_memcached_lru_expires_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",type="unfetched"} 0.000000
openio_memcached_lru_moves_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",type="within_lru"} 134353.000000
openio_memcached_lru_reclaimed_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 2.000000
openio_memcached_malloc_fails{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 0.000000
openio_memcached_rejected_connections{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 0.000000
openio_memcached_cache_commands_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",command="touch",cache="misses"} 0.000000
openio_memcached_size_bytes{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 53341152.000000
openio_memcached_size_bytes_max{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 67108864.000000
openio_memcached_slab_actives_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 6.000000
openio_memcached_slab_chunk_size_bytes{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",slab="8"} 480.000000
openio_memcached_slab_chunks_per_page{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",slab="8"} 2184.000000
openio_memcached_slab_chunks_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",slab="8",type="used"} 1.000000
openio_memcached_slab_commands_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",slab="8",command="touch"} 0.000000
openio_memcached_slab_free_chunks_end{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",slab="8"} 0.000000
openio_memcached_slab_global_page_pool{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 0.000000
openio_memcached_slab_memory_size_bytes_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 67108864.000000
openio_memcached_slab_mem_requested_bytes{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",slab="7"} 315.000000
openio_memcached_slab_pages_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",slab="8"} 1.000000
openio_memcached_slab_reassign_running{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 0.000000
openio_memcached_slab_reassigns{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",type="rescue"} 0.000000
openio_memcached_slabs_moved_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 0.000000
openio_memcached_slab_wasted_bytes{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019",slab="8"} 1047926.000000
openio_memcached_stored_items{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 26616.000000
openio_memcached_stored_items_total{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 247620.000000
openio_memcached_threads{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 4.000000
openio_memcached_uptime_seconds{host="gw",namespace="OPENIO",service_type="memcached",service_addr="172.30.0.111:6019"} 62996.000000
```
